package com.bjsxt.dao.impl;

import com.bjsxt.commons.JDBCUtil;
import com.bjsxt.dao.BaseDao;

import java.sql.Connection;
import java.sql.ParameterMetaData;
import java.sql.PreparedStatement;

public class BaseDaoImpl implements BaseDao {
    @Override
    public int executeUpdate(String sql, Object[] param) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;

        int rows = 0;
        try {
            connection = JDBCUtil.getConnection();
            connection.setAutoCommit(false);
            preparedStatement = connection.prepareStatement(sql);

            // 得到参数的个数
            ParameterMetaData pmd = preparedStatement.getParameterMetaData();

            // 绑定参数
            for (int i = 0; i < pmd.getParameterCount(); i++) {
                preparedStatement.setObject(i + 1, param[i]);
            }
            rows = preparedStatement.executeUpdate();
            connection.commit();
        } catch (Exception e) {
            e.printStackTrace();
            JDBCUtil.rollback(connection);
        } finally {
            JDBCUtil.closeResources(preparedStatement, connection, null);
        }
        return rows;
    }
}
