package com.bjsxt.dao.impl;

import com.bjsxt.commons.JDBCUtil;
import com.bjsxt.dao.StudentDao;
import com.bjsxt.pojo.Students;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 * StudentDao 接口实现类
 */
public class StudentDaoImpl extends BaseDaoImpl implements StudentDao {
    @Override
    public List<Students> selectStuByName(String stu_name) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        ResultSet resultSet = null;
        List<Students> list = new ArrayList<>();
        try {
            connection = JDBCUtil.getConnection();
            connection.setAutoCommit(false);
            preparedStatement = connection.prepareStatement("select * from student1 where stu_name=?");
            preparedStatement.setString(1, stu_name);
            resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                Students s = new Students();
                s.setStu_id(resultSet.getInt("stu_id"));
                s.setStu_name(resultSet.getString("stu_name"));
                s.setStu_email(resultSet.getString("stu_email"));
                list.add(s);
            }
            connection.commit();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            JDBCUtil.closeResources(preparedStatement, connection, null);

        }
        return list;
    }

    @Override
    public void insertStu(Students students) {
        Connection connection = null;
        PreparedStatement preparedStatement = null;
        try {
            connection = JDBCUtil.getConnection();
            connection.setAutoCommit(false);
            preparedStatement = connection.prepareStatement("insert into student1 values(default, ?, ?)");
            preparedStatement.setString(1, students.getStu_name());
            preparedStatement.setString(2, students.getStu_email());
            preparedStatement.execute();
            connection.commit();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        } finally {
            JDBCUtil.closeResources(preparedStatement, connection, null);
        }
    }

    // 更新学生信息
    @Override
    public int updateStudent(Students students) {
        String sql = "update student1 set stu_name = ?, stu_email = ？where stu_id = ?";
        Object[] param = new Object[]{students.getStu_name(), students.getStu_email(), students.getStu_id()};
        return this.executeUpdate(sql, param);
    }
}
